unit hiPerString;

interface

uses Kol,Share,Debug;

type
  THIPerString = class(TDebug)
   private
   FString:string;
   public
    _prop_String:string;
    _prop_Count:integer;
    _prop_Ch:string;

    _data_String:THI_Event;
    _data_Count:THI_Event;
    _data_Ch:THI_Event;
    _event_onString:THI_Event;

    procedure _work_doGroup(var _Data:TData; Index:word);
    procedure _work_doUnGroup(var _Data:TData; Index:word);
    procedure _var_Result(var _Data:TData; Index:word);
  end;

implementation


procedure THIPerString._work_doGroup;
var s,res,ch:string;
var i,pos,c:integer;
begin
    s:=ReadString(_Data,_data_String,_prop_String);
    c:=ReadInteger(_Data,_data_Count,_prop_Count);
    ch:=ReadString(_Data,_data_Ch,_prop_Ch);
    for i:=1 to c do
    begin
      s:=ch + s;
    end;
    res:='';
    i:=length(s);
    while i>0 do
    begin
     pos:=i-(c-1);
     i:=i-c;
     res:=ch + copy(s,pos,c) + res;
    end;
    while res[1]=ch do
    begin
      delete(res,1,1);
    end;
    FString:=res;
    _hi_onEvent(_event_onString,res);
end;

procedure THIPerString._work_doUnGroup;
var s,res,ch:string;
var i:integer;
begin
    s:=ReadString(_Data,_data_String,_prop_String);
    res:='';
    ch:=ReadString(_Data,_data_Ch,_prop_Ch);
    for i:=1 to length(s) do
    if s[i]<>Ch then res:=res+s[i];
    FString:=res;
    _hi_onEvent(_event_onString,res);
end;

procedure THIPerString._var_Result;
begin
    _Data.data_type:=data_str;
    _Data.sdata:=FString;
end;

end.
